SELECT 'Upgrading MetaStore schema from 3.1.3000.7.2.12.0-Update1 to 3.1.3000.7.2.15.0-Update2';

USE SYS;

DROP TABLE IF EXISTS `REPLICATION_METRICS`;

CREATE EXTERNAL TABLE IF NOT EXISTS `REPLICATION_METRICS_ORIG` (
    `SCHEDULED_EXECUTION_ID` bigint,
    `POLICY_NAME` string,
    `DUMP_EXECUTION_ID` bigint,
    `METADATA` string,
    `PROGRESS` string,
    `MESSAGE_FORMAT` varchar(16)
)
STORED BY 'org.apache.hive.storage.jdbc.JdbcStorageHandler'
TBLPROPERTIES (
"hive.sql.database.type" = "METASTORE",
"hive.sql.query" =
"SELECT
    \"RM_SCHEDULED_EXECUTION_ID\",
    \"RM_POLICY\",
    \"RM_DUMP_EXECUTION_ID\",
    \"RM_METADATA\",
    \"RM_PROGRESS\",
    \"MESSAGE_FORMAT\"
FROM \"REPLICATION_METRICS\""
);

CREATE OR REPLACE VIEW `REPLICATION_METRICS` (
    `SCHEDULED_EXECUTION_ID`,
    `POLICY_NAME`,
    `DUMP_EXECUTION_ID`,
    `METADATA`,
    `PROGRESS`
) AS
SELECT DISTINCT
    RM.`SCHEDULED_EXECUTION_ID`,
    RM.`POLICY_NAME`,
    RM.`DUMP_EXECUTION_ID`,
    RM.`METADATA`,
    deserialize(RM.`PROGRESS`, RM.`MESSAGE_FORMAT`)
FROM SYS.`REPLICATION_METRICS_ORIG` AS RM;

CREATE OR REPLACE VIEW SYS.CDH_VERSION AS SELECT 1 AS VER_ID, '3.1.3000.7.2.15.0-Update2' AS SCHEMA_VERSION,
  'Hive release version 3.1.3000 for CDH 7.2.15.0-Update2' AS VERSION_COMMENT;

SELECT 'Finished upgrading MetaStore schema from 3.1.3000.7.2.12.0-Update1 to 3.1.3000.7.2.15.0-Update2';
