--Upgrade file names from cdw-master included

--3.1.3000.7.2.1.0-Update1-to-3.1.3000.7.2.8.0, partial

-- HIVE-23107
ALTER TABLE COMPACTION_QUEUE ADD CQ_NEXT_TXN_ID bigint NULL;

-- HIVE-24291
ALTER TABLE COMPACTION_QUEUE ADD CQ_TXN_ID bigint NULL;
-- HIVE-24275
ALTER TABLE COMPACTION_QUEUE ADD CQ_COMMIT_TIME bigint NULL;


--3.1.3000.7.2.10.0-Update1-to-3.1.3000.7.2.11.0-Update1
-- Create stored procedure tables
CREATE TABLE "STORED_PROCS" (
  "SP_ID" BIGINT NOT NULL,
  "CREATE_TIME" int NOT NULL,
  "DB_ID" BIGINT NOT NULL,
  "NAME" nvarchar(256) NOT NULL,
  "OWNER_NAME" nvarchar(128) NOT NULL,
  "SOURCE" NTEXT NOT NULL,
  PRIMARY KEY ("SP_ID")
);

CREATE UNIQUE INDEX "UNIQUESTOREDPROC" ON "STORED_PROCS" ("NAME", "DB_ID");
ALTER TABLE "STORED_PROCS" ADD CONSTRAINT "STOREDPROC_FK1" FOREIGN KEY ("DB_ID") REFERENCES "DBS" ("DB_ID");

-- Create stored procedure packages
CREATE TABLE "PACKAGES" (
  "PKG_ID" BIGINT NOT NULL,
  "CREATE_TIME" int NOT NULL,
  "DB_ID" BIGINT NOT NULL,
  "NAME" nvarchar(256) NOT NULL,
  "OWNER_NAME" nvarchar(128) NOT NULL,
  "HEADER" NTEXT NOT NULL,
  "BODY" NTEXT NOT NULL,
  PRIMARY KEY ("PKG_ID")
);

CREATE UNIQUE INDEX "UNIQUEPKG" ON "PACKAGES" ("NAME", "DB_ID");
ALTER TABLE "PACKAGES" ADD CONSTRAINT "PACKAGES_FK1" FOREIGN KEY ("DB_ID") REFERENCES "DBS" ("DB_ID");


--3.1.3000.7.2.11.0-Update1-to-3.1.3000.7.2.12.0-Update1
-- HIVE-24880
ALTER TABLE COMPACTION_QUEUE ADD CQ_INITIATOR_ID nvarchar(128) NULL;
ALTER TABLE COMPACTION_QUEUE ADD CQ_INITIATOR_VERSION nvarchar(128) NULL;
ALTER TABLE COMPACTION_QUEUE ADD CQ_WORKER_VERSION nvarchar(128) NULL;
ALTER TABLE COMPLETED_COMPACTIONS ADD CC_INITIATOR_ID nvarchar(128) NULL;
ALTER TABLE COMPLETED_COMPACTIONS ADD CC_INITIATOR_VERSION nvarchar(128) NULL;
ALTER TABLE COMPLETED_COMPACTIONS ADD CC_WORKER_VERSION nvarchar(128) NULL;


-- These lines need to be last.  Insert any changes above.
UPDATE CDH_VERSION SET SCHEMA_VERSION='3.1.3000.7.2.13.0-Update1', VERSION_COMMENT='Hive release version 3.1.3000 for CDH 7.2.13.0' where VER_ID=1;
SELECT 'Finished upgrading MetaStore schema from 3.1.3000.7.2.10.0-Update1 to 3.1.3000.7.2.13.0-Update1' AS MESSAGE;
