--Upgrade file names from cdw-master included

--3.1.3000.7.2.1.0-Update1-to-3.1.3000.7.2.8.0, partial
-- HIVE-23107
ALTER TABLE COMPACTION_QUEUE ADD CQ_NEXT_TXN_ID NUMBER(19);

-- HIVE-24291
ALTER TABLE COMPACTION_QUEUE ADD CQ_TXN_ID NUMBER(19);

-- HIVE-24275
ALTER TABLE COMPACTION_QUEUE ADD CQ_COMMIT_TIME NUMBER(19);


--3.1.3000.7.2.10.0-Update1-to-3.1.3000.7.2.11.0-Update1
-- Create stored procedure tables
CREATE TABLE "STORED_PROCS" (
  "SP_ID" NUMBER NOT NULL,
  "CREATE_TIME" NUMBER(10) NOT NULL,
  "DB_ID" NUMBER NOT NULL,
  "NAME" VARCHAR(256) NOT NULL,
  "OWNER_NAME" VARCHAR(128) NOT NULL,
  "SOURCE" NCLOB NOT NULL,
  PRIMARY KEY ("SP_ID")
);

CREATE UNIQUE INDEX UNIQUESTOREDPROC ON STORED_PROCS ("NAME", "DB_ID");
ALTER TABLE "STORED_PROCS" ADD CONSTRAINT "STOREDPROC_FK1" FOREIGN KEY ("DB_ID") REFERENCES "DBS" ("DB_ID");

-- Create stored procedure tables
CREATE TABLE "PACKAGES" (
  "PKG_ID" NUMBER NOT NULL,
  "CREATE_TIME" NUMBER(10) NOT NULL,
  "DB_ID" NUMBER NOT NULL,
  "NAME" VARCHAR(256) NOT NULL,
  "OWNER_NAME" VARCHAR(128) NOT NULL,
  "HEADER" NCLOB NOT NULL,
  "BODY" NCLOB NOT NULL,
  PRIMARY KEY ("PKG_ID")
);

CREATE UNIQUE INDEX UNIQUEPKG ON PACKAGES ("NAME", "DB_ID");
ALTER TABLE "PACKAGES" ADD CONSTRAINT "PACKAGES_FK1" FOREIGN KEY ("DB_ID") REFERENCES "DBS" ("DB_ID");


--3.1.3000.7.2.11.0-Update1-to-3.1.3000.7.2.12.0-Update1
-- HIVE-24880
ALTER TABLE COMPACTION_QUEUE ADD CQ_INITIATOR_ID varchar(128);
ALTER TABLE COMPACTION_QUEUE ADD CQ_INITIATOR_VERSION varchar(128);
ALTER TABLE COMPACTION_QUEUE ADD CQ_WORKER_VERSION varchar(128);
ALTER TABLE COMPLETED_COMPACTIONS ADD CC_INITIATOR_ID varchar(128);
ALTER TABLE COMPLETED_COMPACTIONS ADD CC_INITIATOR_VERSION varchar(128);
ALTER TABLE COMPLETED_COMPACTIONS ADD CC_WORKER_VERSION varchar(128);


-- These lines need to be last.  Insert any changes above.
UPDATE CDH_VERSION SET SCHEMA_VERSION='3.1.3000.7.2.13.0-Update1', VERSION_COMMENT='Hive release version 3.1.3000 for CDH 7.2.13.0' where VER_ID=1;
SELECT 'Finished upgrading MetaStore schema from 3.1.3000.7.2.10.0-Update1 to 3.1.3000.7.2.13.0-Update1' AS Status from dual;
